---
title: CanvasRenderingContext2D.shadowColor
slug: Web/API/CanvasRenderingContext2D/shadowColor
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.shadowColor</code></strong> property of the Canvas 2D API specifies the color of shadows.</p>

<p>Be aware that the shadow's rendered opacity will be affected by the opacity of the {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}} color when filling, and of the {{domxref("CanvasRenderingContext2D.strokeStyle", "strokeStyle")}} color when stroking.</p>

<div class="notecard note">
<p><strong>Note:</strong> Shadows are only drawn if the <code>shadowColor</code> property is set to a non-transparent value. One of the {{domxref("CanvasRenderingContext2D.shadowBlur", "shadowBlur")}}, {{domxref("CanvasRenderingContext2D.shadowOffsetX", "shadowOffsetX")}}, or {{domxref("CanvasRenderingContext2D.shadowOffsetY", "shadowOffsetY")}} properties must be non-zero, as well.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.shadowColor = <em>color</em>;
</pre>

<dl>
 <dt><code>color</code></dt>
 <dd>A {{domxref("DOMString")}} parsed as a <a href="/en-US/docs/Web/CSS">CSS</a> {{cssxref("&lt;color&gt;")}} value. The default value is fully-transparent black.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Adding_a_shadow_to_shapes">Adding a shadow to shapes</h3>

<p>This example adds a shadow to two squares; the first one is filled, and the second one is stroked. The <code>shadowColor</code> property sets the shadows' color, while <code>shadowOffsetX</code> and <code>shadowOffsetY</code> set their position relative to the shapes.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[5]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Shadow
ctx.shadowColor = 'red';
ctx.shadowOffsetX = 10;
ctx.shadowOffsetY = 10;

// Filled rectangle
ctx.fillRect(20, 20, 100, 100);

// Stroked rectangle
ctx.lineWidth = 6;
ctx.strokeRect(170, 20, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Adding_a_shadow_to_shapes', 700, 180) }}</p>

<h3 id="Shadows_on_translucent_shapes">Shadows on translucent shapes</h3>

<p>A shadow's opacity is affected by the transparency level of its parent object (even when <code>shadowColor</code> specifies a completely opaque value). This example strokes and fills a rectangle with translucent colors.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The resulting alpha value of the fill shadow is <code>.8 * .2</code>, or <code>.16</code>. The alpha of the stroke shadow is <code>.8 * .6</code>, or <code>.48</code>.</p>

<pre class="brush: js; highlight:[5,11,16]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Shadow
ctx.shadowColor = 'rgba(255, 0, 0, .8)';
ctx.shadowBlur = 8;
ctx.shadowOffsetX = 30;
ctx.shadowOffsetY = 20;

// Filled rectangle
ctx.fillStyle = 'rgba(0, 255, 0, .2)';
ctx.fillRect(10, 10, 150, 100);

// Stroked rectangle
ctx.lineWidth = 10;
ctx.strokeStyle = 'rgba(0, 0, 255, .6)';
ctx.strokeRect(10, 10, 150, 100);</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Shadows_on_translucent_shapes', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-shadowcolor", "CanvasRenderingContext2D.shadowColor")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.shadowColor")}}</p>

<h3 id="WebKitBlink-specific_notes">WebKit/Blink-specific notes</h3>

<p>In WebKit- and Blink-based browsers, the non-standard and deprecated method <code>ctx.setShadow()</code> is implemented besides this property.</p>

<pre class="brush: js">setShadow(width, height, blur, color, alpha);
setShadow(width, height, blur, graylevel, alpha);
setShadow(width, height, blur, r, g, b, a);
setShadow(width, height, blur, c, m, y, k, a);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
